function Update()
    Keyboard()
    Mouse()
    UpdateLine()
    BuildShips()
    CreateRandomFleet()
    UpdateFleets()
    UpdateSend()
end

function Keyboard() 
    function love.keypressed(key, scancode, isrepeat)
        if key == "escape" then love.event.quit() end
        if key == "n" then Initiate() end
    end
end

function Mouse()
    mx, my = love.mouse.getPosition()
    function love.mousepressed(x, y, b) 
        mbpx = x
        mbpy = y 
        mbpb = b
    end
    function love.mousereleased(x, y, b)
        mbrx = x
        mbry = y 
        mbrb = b
    end
end

function UpdateLine()
    if not mouseOver then return end
    i = mxyIsStar()
    if i then
        ldx = star[i].x
        ldy = star[i].y 
    else
        ldx = mx
        ldy = my
    end
    if not drawLine then
        if mbrb then
            mbrb = false
            if i then
                lox = star[i].x
                loy = star[i].y
                lo = i
                drawLine = true
            end
        end
    else
        if mbrb then
            mbrb = false
             drawLine = false
             if i and star[lo].owner == 1 then
                mouseOver = false
                sendFleet = true;
             end
        end
    end
end

function CreateRandomFleet()
    if love.math.random(100) < 10 then
        i = fleetTop
        r = love.math.random(12)
        org = player[r]
        dst = player[love.math.random(12)]
        if org ~= dst then
            x1 = star[org].x
            y1 = star[org].y
            x2 = star[dst].x
            y2 = star[dst].y
            dist = math.sqrt((x2 - x1) ^ 2 + (y2 - y1) ^ 2)
            fleet[i].dx = (x2 - x1) / dist
            fleet[i].dy = (y2 - y1) / dist
            fleet[i].owner = r
            fleet[i].x1 = x1
            fleet[i].y1 = y1
            fleet[i].x2 = x2
            fleet[i].y2 = y2
            fleetTop = fleetTop + 1
        end
    end
end

function UpdateFleets() 
    local i = 1
    while i < fleetTop do
        x1 = fleet[i].x1
        y1 = fleet[i].y1
        x2 = fleet[i].x2
        y2 = fleet[i].y2
        dx = fleet[i].dx
        dy = fleet[i].dy
        x1 = x1 + dx
        y1 = y1 + dy
        if math.abs(x2 - x1) < 1 and math.abs(y2 - y1) < 1 then
            fleetTop = fleetTop - 1
            fleet[i] = fleet[fleetTop]
            fleet[fleetTop] = {}
        else
            fleet[i].x1 = x1
            fleet[i].y1 = y1
        end
        i = i + 1    
    end
end

function UpdateSend()
  if not sendFleet then return end
  if mbrb then
      if mbrx >= gx + 416 and mbrx <= gx + 476 and mbry >= gy + 4 and mbry <= gy + 64 then
          sendFleet = false
          mouseOver = true
      end 
  end
end

function BuildShips()
    for i = 1, 200 do
        r = love.math.random(1000)
        if star[i].owner == 13 then
            if r / 4 < star[i].size then
                star[i].ships = star[i].ships + 1
            end
        else
            if r / 8 < star[i].size then
                star[i].ships = star[i].ships + 1
            end
        end   
    end
end